"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  glob: () => glob,
  globSync: () => globSync
});
module.exports = __toCommonJS(src_exports);
var import_node_path = __toESM(require("path"));
var import_fdir = require("fdir");
var import_picomatch = __toESM(require("picomatch"));
function expandDir(pattern) {
  if (pattern.endsWith("/")) {
    return `${pattern}**`;
  }
  if (pattern.endsWith("\\")) {
    return `${pattern.slice(0, -1)}/**`;
  }
  return `${pattern}/**`;
}
function processPatterns({ patterns, ignore = [], expandDirectories = true }) {
  const matchPatterns = [];
  const ignorePatterns = ignore.map((p) => !p.endsWith("*") && expandDirectories ? expandDir(p) : p);
  if (!patterns || patterns.length === 0) {
    return { match: ["**/*"], ignore: ignorePatterns };
  }
  for (let pattern of patterns) {
    if (!pattern.endsWith("*") && expandDirectories) {
      pattern = expandDir(pattern);
    }
    if (pattern.startsWith("!") && pattern[1] !== "(") {
      ignorePatterns.push(pattern.slice(1));
    } else {
      matchPatterns.push(pattern);
    }
  }
  return { match: matchPatterns, ignore: ignorePatterns };
}
function getFdirBuilder(options, cwd) {
  const processed = processPatterns(options);
  const matcher = (0, import_picomatch.default)(processed.match, {
    dot: options.dot,
    ignore: processed.ignore
  });
  const fdirOptions = {
    // use relative paths in the matcher
    filters: [options.absolute ? (p) => matcher(p.slice(cwd.length + 1)) : matcher],
    relativePaths: true
  };
  if (options.deep) {
    fdirOptions.maxDepth = options.deep;
  }
  if (options.absolute) {
    fdirOptions.relativePaths = false;
    fdirOptions.resolvePaths = true;
    fdirOptions.includeBasePath = true;
  }
  if (options.onlyDirectories) {
    fdirOptions.excludeFiles = true;
    fdirOptions.includeDirs = true;
  } else if (options.onlyFiles === false) {
    fdirOptions.includeDirs = true;
  }
  return new import_fdir.fdir(fdirOptions);
}
async function glob(patternsOrOptions, options) {
  if (patternsOrOptions && (options == null ? void 0 : options.patterns)) {
    throw new Error("Cannot pass patterns as both an argument and an option");
  }
  const opts = Array.isArray(patternsOrOptions) ? { ...options, patterns: patternsOrOptions } : patternsOrOptions;
  const cwd = opts.cwd ? import_node_path.default.resolve(opts.cwd) : process.cwd();
  return getFdirBuilder(opts, cwd).crawl(cwd).withPromise();
}
function globSync(patternsOrOptions, options) {
  if (patternsOrOptions && (options == null ? void 0 : options.patterns)) {
    throw new Error("Cannot pass patterns as both an argument and an option");
  }
  const opts = Array.isArray(patternsOrOptions) ? { ...options, patterns: patternsOrOptions } : patternsOrOptions;
  const cwd = opts.cwd ? import_node_path.default.resolve(opts.cwd) : process.cwd();
  return getFdirBuilder(opts, cwd).crawl(cwd).sync();
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  glob,
  globSync
});
//# sourceMappingURL=index.js.map